################################################################################
##                                                                            ##
##      CGI α׷  ƾ                                                ##
##                                                                            ##
##          : () ̸                                           ##
##                                                                            ##
##      E-mail    : arcanian@charim.co.kr                                     ##
##      Home Page : http://charim.co.kr/~arcanian/                            ##
##                                                                            ##
################################################################################

#    print "HTTP1.0/ 200 OK\n";		for Microsoft Windows NT

($cgi_lib'version = '$Revision: 2.8 $') =~ s/[^.\d]//g;

# Parameters affecting cgi-lib behavior
# User-configurable parameters affecting file upload.
$cgi_lib'writefiles = 0;	# directory to which to write files, or
				# 0 if files should not be written
$cgi_lib'filepre = "cgi-lib";	# Prefix of file names, in directory above

# Do not change the following parameters unless you have special reasons
$cgi_lib'bufsize = 8192;	# default buffer size when reading multipart
$cgi_lib'maxbound = 100;	# maximum boundary length to be encounterd
$cgi_lib'headerout = 0;		# indicates whether the header has been printed

$file_max_size = 4194304;
$NO_TITLE = " ";

################################################################################
##  ƾ
################################################################################

sub HeaderNormal {
  my ($htmltitle);

  ($htmltitle) = @_;
  $htmltitle = $NO_TITLE if (!$htmltitle);

  print <<__HEADER_NORMAL__;
Content-type: text/html

<html>
<head>
<title>$htmltitle</title>
</head>
<body>
__HEADER_NORMAL__
}

sub HeaderNoUnderline {
  my ($htmltitle);

  ($htmltitle) = @_;
  $htmltitle = $NO_TITLE if (!$htmltitle);

  print <<__HEADER_NOUNDERLINE__;
Content-type: text/html

<html>
<head>
<title>$htmltitle</title>
<style type="text/css">
<!--
FONT      {font-family: Arial, }
A:link    {text-decoration: none}
A:visited {text-decoration: none}
A:active  {text-decoration: underline}
A:hover   {text-decoration: underline; color: yellow}
-->
</style>
</head>
<body bgcolor=000000 text=ffffff link=ffcc00 alink=ffffff vlink=ff8000>
__HEADER_NOUNDERLINE__
}

sub Footer {
  print <<__FOOTER__;
</body>
</html>
__FOOTER__
}

sub DelayedRefresh {
  my ($url, $delay, $msg);

  ($url, $delay, $msg) = @_;
  print <<__DELAYED_REFRESH__;
Content-type: text/html

<html>
<head>
<title>msg</title>
<meta http-equiv="Refresh" content="$delay; url=$url">
</head>
<body>
<center>
<font size=4><strong>$msg</strong></font><br>
<font size=-1<blink>ø ٷ ּ...</blink></font>
</center>
</body>
</html>
__DELAYED_REFRESH__
}

sub DirectGo {
  my ($url) = @_;

  print "Location: $url\n\n";
}

sub DumpFile {
  my ($filename);

  ($filename) = @_;
  if (!open(hndl, $filename)) {
    &ErrorMsg("\"$filename\"    ϴ.");
  }
  while (<hndl>) {
    print "$_";
  }
  close(hndl);
}

sub DumpHtml {
  my ($filename);

  ($filename) = @_;
  if (!open(hndl, $filename)) {
    &ErrorMsg("\"$filename\" ȭ   ϴ.");
  }

  print "Content-type: text/html\n\n";
  while (<hndl>) {
    print "$_";
  }
  close(hndl);
}

sub ErrorMsg {
  my ($msg);

  ($msg) = @_;
  &HeaderNoUnderline;
print <<__ERROR_MSG__;
<center>
<font face="Arial" size=4><b>Error has occurred!</b></font><br><br>
<font size=2 color=00ff00><b>"$msg"</b></font><br><br>
<a href="javascript:history.back()"><font size=2><b>ڷ</b></font></a>
</center>
__ERROR_MSG__
  &Footer;
  exit(0);
}

################################################################################
##  ƾ 
################################################################################

sub ParseArguments {
  local (*in) = shift if @_;	# CGI Է
  local (*incfn,		# Ŭ̾Ʈ ϸ (may not be provided)
         *inct,			# Ŭ̾Ʈ Content-type ('')
         *insfn) = @_;		#  ϸ (for spooled files)
  local ($len, $type, $meth, $errflag, $cmdflag, $perlwarn);

  binmode(STDIN);
  binmode(STDOUT);
  binmode(STDERR);
  # Disable warnings as this code deliberately uses local and environment
  # variables which are preset to undef (i.e., not explicitly initialized)
  $perlwarn = $^W;
  $^W = 0;

  $type = $ENV{'CONTENT_TYPE'};
  $len  = $ENV{'CONTENT_LENGTH'};
  $meth = $ENV{'REQUEST_METHOD'};

  if ($len > $file_max_size) {
      &ErrorMsg(" 뷮 ʰ: $file_max_size Ʈ ϸ ");
  }

  if (!defined $meth || $meth eq '' || $meth eq 'GET' ||
      $type eq 'application/x-www-form-urlencoded') {
    local ($key, $val, $i);

    if (!defined $meth || $meth eq '') {
      $in = $ENV{'QUERY_STRING'};
      $cmdflag = 1;  # also use command-line options
    }
    elsif ($meth eq 'GET' || $meth eq 'HEAD') {
      $in = $ENV{'QUERY_STRING'};
    }
    elsif ($meth eq 'POST') {
      $errflag = (read(STDIN, $in, $len) != $len);
    }
    else {
      &ErrorMsg("cgi-lib.pl: Unknown request method: $meth\n");
    }

    @in = split(/[&;]/, $in);
    push(@in, @ARGV) if $cmdflag;	# add command-line parameters

    foreach $i (0 .. $#in) {
      # Convert plus to space
      $in[$i] =~ s/\+/ /g;

      # Split into key and value.
      ($key, $val) = split(/=/, $in[$i], 2);	# splits on the first =.

      # Convert %XX from hex numbers to alphanumeric
      $key =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;
      $val =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;

      # Associate key and value
      $in{$key} .= "\0" if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
    }
  }
  elsif ($ENV{'CONTENT_TYPE'} =~ m#^multipart/form-data#) {
    # for efficiency, compile multipart code only if needed
    $errflag = !(eval <<'END_MULTIPART');

    local ($buf, $boundary, $head, @heads, $cd, $ct, $fname, $ctype, $blen);
    local ($bpos, $lpos, $left, $amt, $fn, $ser);
    local ($bufsize, $maxbound, $writefiles) =
      ($cgi_lib'bufsize, $cgi_lib'maxbound, $cgi_lib'writefiles);

    # The following lines exist solely to eliminate spurious warning messages
    $buf = '';

    ($boundary) = $type =~ /boundary="([^"]+)"/; #";	# find boundary
    ($boundary) = $type =~ /boundary=(\S+)/ unless $boundary;
    &ErrorMsg("Boundary not provided") unless $boundary;
    $boundary =  "--" . $boundary;
    $blen = length ($boundary);

    if ($ENV{'REQUEST_METHOD'} ne 'POST') {
      &ErrorMsg("Invalid request method for  multipart/form-data: $meth\n");
    }

    if ($writefiles) {
      local($me);
      stat($writefiles);
      $writefiles = "/tmp" unless  -d _ && -r _ && -w _;
      # ($me) = $0 =~ m#([^/]*)$#;
      $writefiles .= "/$cgi_lib'filepre";
    }

    # read in the data and split into parts:
    # put headers in @in and data in %in
    # General algorithm:
    #   There are two dividers: the border and the '\r\n\r\n' between
    # header and body.  Iterate between searching for these
    #   Retain a buffer of size(bufsize+maxbound); the latter part is
    # to ensure that dividers don't get lost by wrapping between two bufs
    #   Look for a divider in the current batch.  If not found, then
    # save all of bufsize, move the maxbound extra buffer to the front of
    # the buffer, and read in a new bufsize bytes.  If a divider is found,
    # save everything up to the divider.  Then empty the buffer of everything
    # up to the end of the divider.  Refill buffer to bufsize+maxbound
    #   Note slightly odd organization.  Code before BODY: really goes with
    # code following HEAD:, but is put first to 'pre-fill' buffers.  BODY:
    # is placed before HEAD: because we first need to discard any 'preface,'
    # which would be analagous to a body without a preceeding head.

    $left = $len;
   PART:	# find each part of the multi-part while reading data
    while (1) {
      last PART if $errflag;

      $amt = ($left > $bufsize + $maxbound - length($buf)
              ? $bufsize + $maxbound - length($buf): $left);
      $errflag = (read(STDIN, $buf, $amt, length($buf)) != $amt);
      $left -= $amt;

      $in{$name} .= "\0" if defined $in{$name};
      $in{$name} .= $fn if $fn;

      $name =~ /([-\w]+)/;	# This allows $insfn{$name} to be untainted
      if (defined $1) {
        $insfn{$1} .= "\0" if defined $insfn{$1};
        $insfn{$1} .= $fn if $fn;
      }

     BODY:
      while (($bpos = index($buf, $boundary)) == -1) {
        if ($name) {	# if no $name, then it's the prologue -- discard
          if ($fn) {
            print FILE substr($buf, 0, $bufsize);
          }
          else {
            $in{$name} .= substr($buf, 0, $bufsize);
          }
        }
        $buf = substr($buf, $bufsize);
        $amt = ($left > $bufsize ? $bufsize : $left);  #$maxbound==length($buf);
        $errflag = (read(STDIN, $buf, $amt, $maxbound) != $amt);
        $left -= $amt;
      }
      if (defined $name) {	# if no $name, then it's the prologue -- discard
        if ($fn) {
          print FILE substr($buf, 0, $bpos - 2);
        }
        else {
          $in {$name} .= substr($buf, 0, $bpos-2);	# kill last \r\n
        }
      }
      close (FILE);
      last PART if substr($buf, $bpos + $blen, 4) eq "--\r\n";
      substr($buf, 0, $bpos + $blen + 2) = '';
      $amt = ($left > $bufsize + $maxbound - length($buf) ?
               $bufsize + $maxbound - length($buf) : $left);
      $errflag = (read(STDIN, $buf, $amt, length($buf)) != $amt);
      $left -= $amt;

      undef $head;
      undef $fn;
     HEAD:
      while (($lpos = index($buf, "\r\n\r\n")) == -1) {
        $head .= substr($buf, 0, $bufsize);
        $buf = substr($buf, $bufsize);
        $amt = ($left > $bufsize ? $bufsize : $left);  #$maxbound==length($buf);
        $errflag = (read(STDIN, $buf, $amt, $maxbound) != $amt);
        $left -= $amt;
      }
      $head .= substr($buf, 0, $lpos + 2);
      push (@in, $head);
      @heads = split("\r\n", $head);
      ($cd) = grep (/^\s*Content-Disposition:/i, @heads);
      ($ct) = grep (/^\s*Content-Type:/i, @heads);

      ($name) = $cd =~ /\bname="([^"]+)"/i; #";
      ($name) = $cd =~ /\bname=([^\s:;]+)/i unless defined $name;

      ($fname) = $cd =~ /\bfilename="([^"]*)"/i; #";  # filename can be null-str
      ($fname) = $cd =~ /\bfilename=([^\s:;]+)/i unless defined $fname;
      $incfn{$name} .= (defined $in{$name} ? "\0" : "") . $fname;

      ($ctype) = $ct =~ /^\s*Content-type:\s*"([^"]+)"/i;  #";
      ($ctype) = $ct =~ /^\s*Content-Type:\s*([^\s:;]+)/i unless defined $ctype;
      $inct{$name} .= (defined $in{$name} ? "\0" : "") . $ctype;

      if ($writefiles && defined $fname) {
        $ser++;
        $fn = $writefiles . ".$$.$ser";
        open (FILE, ">$fn") || &ErrorMsg("Couldn't open $fn\n");
      }
      substr($buf, 0, $lpos + 4) = '';
      undef $fname;
      undef $ctype;

      @arc_temp = split(/\\/, $cd);
      if ($#arc_temp) {
        $ENV{'filename'} = $arc_temp[$#arc_temp] if $#arc_temp;
        chop($ENV{'filename'});

        @arc_temp = split(/: /, $ct);
        $ENV{'filetype'} = $arc_temp[$#arc_temp];
      }
    }

1;
END_MULTIPART
    &ErrorMsg($@) if $errflag;
  }
  else {
    &ErrorMsg("cgi-lib.pl: Unknown Content-type: $ENV{'CONTENT_TYPE'}\n");
  }


  $^W = $perlwarn;

  return ($errflag ? undef :  scalar(@in));
}

################################################################################
## Խǿ ƾ
################################################################################

$DIR_IMAGES = "./images";

$DELIM = "\0";

$DN_MESGS = "messages";
$DN_FILES = "files";

%TypeIMG = (
  "text/plain",                    "$DIR_IMAGES/txt.gif",
  "text/html",                     "$DIR_IMAGES/html.gif",
  "application/x-zip-compressed",  "$DIR_IMAGES/zip.gif",
  "application/x-gzip-compressed", "$DIR_IMAGES/zip.gif",
  "image/gif",                     "$DIR_IMAGES/gif.gif",
  "image/pjpeg",                   "$DIR_IMAGES/jpg.gif",
  "video/mpeg",                    "$DIR_IMAGES/mpg.gif"
);

%ExtIMG = (
  "exe", "$DIR_IMAGES/exe.gif",
  "com", "$DIR_IMAGES/exe.gif",
  "arj", "$DIR_IMAGES/zip.gif",
  "rar", "$DIR_IMAGES/zip.gif",
  "lzh", "$DIR_IMAGES/zip.gif",
  "ace", "$DIR_IMAGES/zip.gif"
);

sub ReadConfig {
  my (@list);

  $CFG{'title'}        = "ԽǸ";
  $CFG{'descript'}     = "Խ ";
  $CFG{'img_title'}    = "$DIR_IMAGES/arcboard.gif";
  $CFG{'recs_page'}    = 15;
  $CFG{'url_home'}     = "http://charim.co.kr/~arcanian/";
  $CFG{'email'}        = "arcanian\@charim.co.kr";
  $CFG{'passwd'}       = &CryptPassword("arcanian");

  $CFG{'img_tbg'}      = "$DIR_IMAGES/tbg.gif";
  $CFG{'img_search1'}  = "$DIR_IMAGES/bust2.gif";
  $CFG{'img_search2'}  = "$DIR_IMAGES/bust1.gif";
  $CFG{'img_bullet0'}  = "$DIR_IMAGES/red0.gif";
  $CFG{'img_bullet1'}  = "$DIR_IMAGES/red1.gif";
  $CFG{'img_bullet2'}  = "$DIR_IMAGES/red2.gif";
  $CFG{'img_bullet3'}  = "$DIR_IMAGES/red3.gif";

  $CFG{'img_admin'}    = "";
  $CFG{'img_toadmin'}  = "";
  $CFG{'img_prevpage'} = "";
  $CFG{'img_nextpage'} = "";
  $CFG{'img_home'}     = "";
  $CFG{'img_list'}     = "";
  $CFG{'img_write'}    = "";
  $CFG{'img_reply'}    = "";
  $CFG{'img_modify'}   = "";
  $CFG{'img_delete'}   = "";
  $CFG{'img_prevmesg'} = "";
  $CFG{'img_nextmesg'} = "";

  $CFG{'bg_html'}      = "000000";
  $CFG{'fg_html'}      = "ffffff";
  $CFG{'fg_link'}      = "ffcc00";
  $CFG{'fg_vlink'}     = "ff8000";
  $CFG{'fg_alink'}     = "ffffff";
  $CFG{'fg_hlink'}     = "ffff00";
  $CFG{'bg_title'}     = "000000";
  $CFG{'fg_title'}     = "ffffff";
  $CFG{'bg_desc'}      = "660000";
  $CFG{'fg_desc'}      = "ffffff";
  $CFG{'bg_menu'}      = "660000";
  $CFG{'fg_menu1'}     = "ffffff";
  $CFG{'fg_menu2'}     = "00ff00";
  $CFG{'bg_head'}      = "666666";
  $CFG{'fg_head'}      = "ffffff";
  $CFG{'fg_today'}     = "ff0000";
  $CFG{'fg_date'}      = "ffffff";
  $CFG{'fg_hits'}      = "999999";
  $CFG{'bg_search'}    = "000000";
  $CFG{'fg_search'}    = "ffffff";
  $CFG{'bg_tbg'}       = "333333";
  $CFG{'fg_disabled'}  = "990000";

  $CFG{'bg_message'}   = "222222";
  $CFG{'fg_message'}   = "ffffff";
  $CFG{'fg_mesghead1'} = "999999";
  $CFG{'fg_mesghead2'} = "ffffff";
  $CFG{'fg_thistitle'} = "ffffff";

  $CFG{'fg_highlight'} = "ff0000";

  $CFG{'fg_srchead1'}  = "ffffff";
  $CFG{'fg_srchead2'}  = "ffff00";
  $CFG{'fg_srcmatch'}  = "00ff00";
  $CFG{'fg_matchno'}   = "ffff00";

  if (open(FILE, "./$DB/CONFIG")) {
    @list = <FILE>;
    close(FILE);
    foreach $line (@list) {
      ($name, $value) = split(/$DELIM/, $line);
      chomp($value);
      $CFG{$name} = $value;
    }
  }
  elsif (open(FILE, ">./$DB/CONFIG")) {
    foreach $key (keys %CFG) {
      print FILE "$key".$DELIM."$CFG{$key}\n";
    }
    close(FILE);
  }
}

sub Text2Html {
  ($str) = @_;

  $str =~ s/&/&amp;/g;
  $str =~ s/</&lt;/g;
  $str =~ s/>/&gt;/g;
  $str =~ s/"/&quot;/g;
  $str =~ s/\cM//g;

  return $str;
}

sub HeaderNoUnderline1 {
  my ($htmltitle);

  ($htmltitle) = @_;
  $htmltitle = $NO_TITLE if (!$htmltitle);

  print <<__HEADER_NOUNDERLINE__;
Content-type: text/html

<html>
<head>
<title>$htmltitle</title>
<style type="text/css">
<!--
FONT      {font-family: Arial, }
A:link    {text-decoration: none}
A:visited {text-decoration: none}
A:active  {text-decoration: underline}
A:hover   {text-decoration: underline; color: $CFG{'fg_hlink'}}
-->
</style>
</head>
<body bgcolor=$CFG{'bg_html'} text=$CFG{'fg_html'} link=$CFG{'fg_link'} alink=$CFG{'fg_alink'} vlink=$CFG{'fg_vlink'}>
__HEADER_NOUNDERLINE__
}

sub CryptPassword {
  my ($oPassword, $cpassword);
  ($oPassword) = @_;

  srand($$|time);
  @saltchars = (a..z,A..Z,0..9,'.','/');
  $salt = $saltchars[9];
  $salt .= $saltchars[3];
  $cpassword = crypt($oPassword, $salt);
}

sub FsizeStr {
  local ($file) = @_;
  local ($f_size);

  $f_size = (stat($file))[7];
  $f_size = ($f_size >= 1024 * 1000 ? int($f_size / 1024 / 1000) . "," . ($f_size / 1024 % 1000) . "K" :
             $f_size >= 1024 ? int($f_size / 1024) . "K" :
             $f_size . "B");
  return ($f_size);
}

################################################################################
##  ƾ
################################################################################

sub ListENV {
  my ($name);

  &HeaderNormal;
  print "<table>\n";
  foreach $name (keys %ENV) {
    print "<tr>\n";
    print "<td>$name</td>\n";
    print "<td>\"$ENV{$name}\"</td>\n";
    print "</tr>\n";
  }
  print "</table>\n";
  &Footer;
}

sub ListArguments {
  my ($name);

  &HeaderNormal;
  print "<table>\n";
  foreach $name (keys %Argument) {
    print "<tr>\n";
    print "<td>$name</td>\n";
    print "<td>\"$Argument{$name}\"</td>\n";
    print "</tr>\n";
  }
  print "</table>\n";
  &Footer;
}
