#!/usr/local/bin/perl

require("cgi-lib.pl");

################################################################################
##                                                                            ##
##       ƸīϾ  Խ                                               ##
##                                                                            ##
##       : ̸                                                       ##
##                                                                            ##
##       E-mail: arcanian@charim.co.kr                                        ##
##       Homepage: http://charim.co.kr/~arcanian/                             ##
##                                                                            ##
################################################################################

&ParseArguments(*Argument);
$DB = $Argument{'db'};
&ErrorMsg("No DB is given!") if (!$DB);
&ReadConfig;
&ReadArticle;

sub ReadArticle {
  my (@Prev, @Next);

  $Keyword = $Argument{'keyword'};
  $cName = $Argument{'cname'};
  $cTitle = $Argument{'ctitle'};
  $cContent = $Argument{'ccontent'};

  if (!open(FILE, "./$DB/INDEX")) {
    &ErrorMsg("ε    ϴ.");
  }
  @list = <FILE>;
  close(FILE);
  $Num = scalar(@list);

  $index = 0;
  foreach $line (@list) {
    ($Serial, $Depth, $ID, $Name, $Email, $Password, $Date, $Title, $Fname, $Ftype, $Inq) = split(/$DELIM/, $line);
    last if ($Serial eq $Argument{'serial'});
    $index++;
  }
  $CurPage = int($index / $CFG{'recs_page'}) + 1;

  if ($Serial ne $Argument{'serial'}) {
    &ErrorMsg("ε  ԽùԴϴ: $Argument{'serial'}");
  }
  if (!open(FILE, "./$DB/$DN_MESGS/$Serial.txt")) {
    &ErrorMsg("   ԽùԴϴ: $Serial");
  }
  @Content = <FILE>;
  close(FILE);

  if (open(FILE, ">./$DB/INDEX")) {
    $Inq++;
    $list[$index] = "$Serial".$DELIM."$Depth".$DELIM."$ID".$DELIM."$Name".$DELIM."$Email".$DELIM."$Password".$DELIM."$Date".$DELIM."$Title".$DELIM."$Fname".$DELIM."$Ftype".$DELIM."$Inq\n";
    print FILE @list;
    close(FILE);
  }

  &HeaderNoUnderline1("$Title");
  print "<center>\n";

  print "<table width=600 border=0 cellpadding=2 cellspacing=0>\n";
  print "<tr><td align=center bgcolor=$CFG{'bg_title'}>\n";
  if ($CFG{'img_title'}) {
    print "<img src=\"$CFG{'img_title'}\" border=0 alt=\"$CFG{'title'}\">\n";
  }
  else {
    print "<font size=4 color=$CFG{'fg_title'}><b>&nbsp;$CFG{'title'}</b></font>
\n";
  }
  print "</td></tr>\n";
  print "</table>\n";
  print "<img src=\"$DIR_IMAGES/space.gif\" width=10 height=1 border=0><br>\n";

  print "<table width=600 border=0 cellpadding=1 cellspacing=0 valign=top>\n";
  print "<tr bgcolor=$CFG{'bg_menu'}>\n";
  print "<td width=300>\n";
  print "<font size=2>&nbsp;";
  if ($index > 0) {
    @Prev = split(/$DELIM/, $list[$index - 1]);
    $serial = $Prev[0];
    print "<a href=\"./read.cgi?db=$DB&serial=$serial\" onMouseOver=\"window.status=('Serial Number : $Prev[0]'); return true\" onMouseOut=\"window.status=('')\">";
    if ($CFG{'img_prevmesg'}) {
      print "<img src=\"$CFG{'img_prevmesg'}\" border=0 alt=\"\">";
    }
    else {
      print "<b></b>";
    }
    print "</a>&nbsp;|&nbsp;";
  }
  else {
    if ($CFG{'img_prevmesg'}) {
      print "<img src=\"$CFG{'img_prevmesg'}\" border=0 alt=\" \">";
    }
    else {
      print "<font color=$CFG{'fg_disabled'}><b></b></font>";
    }
    print "&nbsp;|&nbsp;";
  }
  if ($index < $Num - 1) {
    @Next = split(/$DELIM/, $list[$index + 1]);
    $serial = $Next[0];
    print "<a href=\"./read.cgi?db=$DB&serial=$serial\" onMouseOver=\"window.status=('Serial Number : $Next[0]'); return true\" onMouseOut=\"window.status=('')\">";
    if ($CFG{'img_nextmesg'}) {
      print "<img src=\"$CFG{'img_nextmesg'}\" border=0 alt=\"\">";
    }
    else {
      print "<b></b>";
    }
    print "</a>&nbsp;";
  }
  else {
    if ($CFG{'img_nextmesg'}) {
      print "<img src=\"$CFG{'img_nextmesg'}\" border=0 alt=\" \">";
    }
    else {
      print "<font color=$CFG{'fg_disabled'}><b></b></font>";
    }
    print "&nbsp;";
  }
  print "</font>\n";
  print "</td>\n";
  print "<td width=300 align=right>\n";
  print "<font size=2>";
  print "<a href=\"./list.cgi?db=$DB&page=$CurPage\" onMouseOver=\"window.status=('List the articles'); return true\" onMouseOut=\"window.status=('')\">";
  if ($CFG{'img_list'}) {
    print "<img src=\"$CFG{'img_list'}\" border=0 alt=\"Խù \">";
  }
  else {
    print "<b></b>";
  }
  print "</a>&nbsp;|&nbsp;";
  print "<a href=\"./write.cgi?db=$DB&serial=$Argument{'serial'}\" onMouseOver=\"window.status=('Post a reply'); return true\" onMouseOut=\"window.status=('')\">";
  if ($CFG{'img_reply'}) {
    print "<img src=\"$CFG{'img_reply'}\" border=0 alt=\"亯 ۼ\">";
  }
  else {
    print "<b>亯</b>";
  }
  print "</a>&nbsp;|&nbsp;";
  print "<a href=\"./password.cgi?db=$DB&mode=modify&serial=$Argument{'serial'}\" onMouseOver=\"window.status=('Modify this article'); return true\" onMouseOut=\"window.status=('')\">";
  if ($CFG{'img_modify'}) {
    print "<img src=\"$CFG{'img_modify'}\" border=0 alt=\"Խù \">";
  }
  else {
    print "<b></b>";
  }
  print "</a>&nbsp;|&nbsp;";
  print "<a href=\"./password.cgi?db=$DB&mode=delete&serial=$Argument{'serial'}\" onMouseOver=\"window.status=('Delete this article'); return true\" onMouseOut=\"window.status=('')\">";
  if ($CFG{'img_delete'}) {
    print "<img src=\"$CFG{'img_delete'}\" border=0 alt=\"Խù \">";
  }
  else {
    print "<b></b>";
  }
  print "</a>&nbsp;";
  print "</font>\n";
  print "</td>\n";
  print "</tr>\n";
  print "</table>\n";
  print "<img src=\"$DIR_IMAGES/space.gif\" width=10 height=1 border=0><br>\n";

  $hKeyword = &Text2Html($Keyword);

  print "<table width=600 border=0 bgcolor=$CFG{'bg_message'} cellpadding=1 cellspacing=0>\n";
  print "<tr><td width=100%>\n";
  print "<br>\n";
  print "<ul>\n";
  print "<table cellpadding=1 cellspacing=0 border=0>\n";

  $Title = &Text2Html($Title);
  if ($Keyword && $cTitle) {
    $Title =~ s/$hKeyword/<font color=$CFG{'fg_srcmatch'}>$hKeyword<\/font>/g;
  }
  print "<tr>\n";
  print "<td align=right width=40 valign=top>";
  print "<font size=2 color=$CFG{'fg_mesghead1'}>";
  print "<b>:&nbsp;</b>";
  print "</font><br>";
  print "</td>\n";
  print "<td>";
  print "<font size=2 color=$CFG{'fg_mesghead2'}>";
  print "$Title";
  print "</font>";
  print "</td>\n";
  print "</tr>\n";

  $Str = &Text2Html($Name);
  if ($Keyword && $cName) {
    $Str =~ s/$hKeyword/<font color=$CFG{'fg_srcmatch'}>$hKeyword<\/font>/g;
  }
  print "<tr>\n";
  print "<td align=right>";
  print "<font size=2 color=$CFG{'fg_mesghead1'}>";
  print "<b≯:&nbsp;</b>";
  print "</font>";
  print "</td>\n";
  print "<td>";
  print "<font size=2>";
  if ($Email) {
    print "<a href=\"mailto:$Email\" onMouseOver=\"window.status=('Send mail to the Author'); return true\" onMouseOut=\"window.status=('')\">$Str</a>";
  }
  else {
    print "<font color=$CFG{'fg_mesghead2'}>$Str</font>";
  }
  print "<font color=$CFG{'fg_mesghead2'}>&nbsp;(from $ID)</font>";
  print "</font>";
  print "</td>\n";
  print "</tr>\n";

  @wd_str = ("", "", "", "", "", "", "");
  ($sec, $min, $hour, $mday, $mon, $year, $wday, $ydat, $isdst) = localtime($Date);
  ($csec, $cmin, $chour, $cmday, $cmon, $cyear, $cwday, $cydat, $cisdst) = localtime();
  $Str = sprintf("%04d/%02d/%02d(%s) %02d:%02d:%02d",
                 ($year < 70) ? $year + 2000 : $year + 1900, $mon + 1, $mday,
                 $wd_str[$wday], $hour, $min, $sec);
  print "<tr>\n";
  print "<td align=right>";
  print "<font size=2 color=$CFG{'fg_mesghead1'}>";
  print "<b>¥:&nbsp;</b>";
  print "</font>";
  print "</td>\n";
  print "<td>";
  if ($year == $cyear && $mon == $cmon && $mday == $cmday) {
    print "<font size=2 color=$CFG{'fg_today'}>$Str</font>";
  }
  else {
    print "<font size=2 color=$CFG{'fg_mesghead2'}>$Str</font>";
  }
  print "</td>\n";
  print "</tr>\n";

  print "</table>\n";
  print "</ul>\n";

  $n = scalar(@Content);
  if ($Keyword && $cContent) {
    for ($i = 0; $i < $n; $i++) {
      $Content[$i] =~ s/$hKeyword/<font color=$CFG{'fg_srcmatch'}>$hKeyword<\/font>/g;
    }
  }
  for ($i = 0; $i < $n; $i++) {
    $Content[$i] =~ s/\n/ <br>\n/g;
    $Content[$i] =~ s/  /&nbsp; /g;
    $Content[$i] =~ s/^ /&nbsp;/g;
  }

  print "<font size=2 color=$CFG{'fg_message'}>\n";
  print "<blockquote>\n";
  print @Content;
  print "<img src=\"$DIR_IMAGES/space.gif\" width=10 height=10 border=0><br>\n";
  if ($Fname) {
    $szStr = &FsizeStr("./$DB/$DN_FILES/$Fname");
    print "<table border=0 cellpadding=2 cellspacing=0 valign=top>\n";
    print "<tr><td>";
    print "<font size=2 color=$CFG{'fg_mesghead1'}><b>Attached File: </b></font>";
    if ($TypeIMG{$Ftype}) {
      $imgIcon = $TypeIMG{$Ftype};
    }
    else {
      foreach $ext (keys %ExtIMG) {
        $strMatch = "\\.$ext\$";
        if ($Fname =~ /$strMatch/i) {
          $imgIcon = $ExtIMG{$ext};
          last;
        }
      }
    }
    $imgIcon = "$DIR_IMAGES/unknown.gif" if (!$imgIcon);

    print "<img src=\"$imgIcon\" width=16 height=16 border=0 align=absmiddle alt=\"$Fname\">";
    print " <font size=2><a href=\"./$DB/$DN_FILES/$Fname\">$Fname</a> ($szStr)</font>\n";
    print "</td></tr>\n";
    print "</table>\n";
  }
  print "</blockquote>\n";
  print "</font>\n";
  print "</td></tr>\n";
  print "</table>\n";
  print "<img src=\"$DIR_IMAGES/space.gif\" width=10 height=1 border=0><br>\n";

  print "<table width=600 border=0 cellpadding=1 cellspacing=0 valign=top>\n";
  print "<tr bgcolor=$CFG{'bg_menu'}>\n";
  print "<td width=300>\n";
  print "<font size=2>&nbsp;";
  if ($index > 0) {
    @Prev = split(/$DELIM/, $list[$index - 1]);
    $serial = $Prev[0];
    print "<a href=\"./read.cgi?db=$DB&serial=$serial\" onMouseOver=\"window.status=('Serial Number : $Prev[0]'); return true\" onMouseOut=\"window.status=('')\">";
    if ($CFG{'img_prevmesg'}) {
      print "<img src=\"$CFG{'img_prevmesg'}\" border=0 alt=\"\">";
    }
    else {
      print "<b></b>";
    }
    print "</a>&nbsp;|&nbsp;";
  }
  else {
    if ($CFG{'img_prevmesg'}) {
      print "<img src=\"$CFG{'img_prevmesg'}\" border=0 alt=\" \">";
    }
    else {
      print "<font color=$CFG{'fg_disabled'}><b></b></font>";
    }
    print "&nbsp;|&nbsp;";
  }
  if ($index < $Num - 1) {
    @Next = split(/$DELIM/, $list[$index + 1]);
    $serial = $Next[0];
    print "<a href=\"./read.cgi?db=$DB&serial=$serial\" onMouseOver=\"window.status=('Serial Number : $Next[0]'); return true\" onMouseOut=\"window.status=('')\">";
    if ($CFG{'img_nextmesg'}) {
      print "<img src=\"$CFG{'img_nextmesg'}\" border=0 alt=\"\">";
    }
    else {
      print "<b></b>";
    }
    print "</a>&nbsp;";
  }
  else {
    if ($CFG{'img_nextmesg'}) {
      print "<img src=\"$CFG{'img_nextmesg'}\" border=0 alt=\" \">";
    }
    else {
      print "<font color=$CFG{'fg_disabled'}><b></b></font>";
    }
    print "&nbsp;";
  }
  print "</font>\n";
  print "</td>\n";
  print "<td width=300 align=right>\n";
  print "<font size=2>";
  print "<a href=\"./list.cgi?db=$DB&page=$CurPage\" onMouseOver=\"window.status=('List the articles'); return true\" onMouseOut=\"window.status=('')\">";
  if ($CFG{'img_list'}) {
    print "<img src=\"$CFG{'img_list'}\" border=0 alt=\"Խù \">";
  }
  else {
    print "<b></b>";
  }
  print "</a>&nbsp;|&nbsp;";
  print "<a href=\"./write.cgi?db=$DB&serial=$Argument{'serial'}\" onMouseOver=\"window.status=('Post a reply'); return true\" onMouseOut=\"window.status=('')\">";
  if ($CFG{'img_reply'}) {
    print "<img src=\"$CFG{'img_reply'}\" border=0 alt=\"亯 ۼ\">";
  }
  else {
    print "<b>亯</b>";
  }
  print "</a>&nbsp;|&nbsp;";
  print "<a href=\"./password.cgi?db=$DB&mode=modify&serial=$Argument{'serial'}\" onMouseOver=\"window.status=('Modify this article'); return true\" onMouseOut=\"window.status=('')\">";
  if ($CFG{'img_modify'}) {
    print "<img src=\"$CFG{'img_modify'}\" border=0 alt=\"Խù \">";
  }
  else {
    print "<b></b>";
  }
  print "</a>&nbsp;|&nbsp;";
  print "<a href=\"./password.cgi?db=$DB&mode=delete&serial=$Argument{'serial'}\" onMouseOver=\"window.status=('Delete this article'); return true\" onMouseOut=\"window.status=('')\">";
  if ($CFG{'img_delete'}) {
    print "<img src=\"$CFG{'img_delete'}\" border=0 alt=\"Խù \">";
  }
  else {
    print "<b></b>";
  }
  print "</a>&nbsp;";
  print "</font>\n";
  print "</td>\n";
  print "</tr>\n";
  print "</table>\n";
  print "<img src=\"$DIR_IMAGES/space.gif\" width=10 height=10 border=0><br>\n";

  print "<table width=600 cellspacing=0 cellpadding=1 border=0 valign=top>\n";
  print "<tr bgcolor=$CFG{'bg_head'}>\n";
  print "<td width=390>";
  print "<font size=2 color=$CFG{'fg_head'}><b>&nbsp; </b></font><br>";
  print "<img src=\"$DIR_IMAGES/space.gif\" width=388 height=1 border=0>";
  print "</td>\n";
  print "<td width=80>";
  print "<font size=2 color=$CFG{'fg_head'}><b> </b></font><br>";
  print "<img src=\"$DIR_IMAGES/space.gif\" width=78 height=1 border=0>";
  print "</td>\n";
  print "<td width=70>";
  print "<font size=2 color=$CFG{'fg_head'}><b>¥</b></font><br>";
  print "<img src=\"$DIR_IMAGES/space.gif\" width=68 height=1 border=0>";
  print "</td>\n";
  print "<td width=40 align=center>";
  print "<font size=2 color=$CFG{'fg_head'}><b>ȸ</b></font><br>";
  print "<img src=\"$DIR_IMAGES/space.gif\" width=38 height=1 border=0>";
  print "</td>\n";
  print "<td width=20 align=center>";
  print "<font size=2 color=$CFG{'fg_head'}><b></b></font><br>";
  print "<img src=\"$DIR_IMAGES/space.gif\" width=18 height=1 border=0>";
  print "</td>\n";
  print "</tr>\n";

  for ($i = $index; $i >= 0; $i--) {
    @article = split(/$DELIM/, $list[$i]);
    last if (!$article[1]);
  }

  $parent = $i;
  ($csec, $cmin, $chour, $cmday, $cmon, $cyear, $cwday, $cydat, $cisdst) = localtime();

  $ok = 0;
  for ($i = $parent; $i < $Num; $i++) {
   ($Serial, $Depth, $ID, $Name, $Email, $Password, $Date, $Title, $Fname, $Ftype, $Inq) = split(/$DELIM/, $list[$i]);
    chomp($Inq);

    last if (!$Depth && $ok);
    $ok = 1 if (!$Depth);

    if (!$CFG{'img_tbg'}) {
      print "<tr bgcolor=$CFG{'bg_tbg'}>\n";
    }
    else {
      print "<tr>\n";
    }

    $gap = $Depth * 20 + 2;
    $tnum = $Depth;
    $tnum = 3 if ($tnum > 3);

    $Str = &Text2Html($Title);
    $bullet = $CFG{"img_bullet$tnum"};
    print "<td background=\"$CFG{'img_tbg'}\" valign=top>\n";
    print "<table cellspacing=0 cellpadding=0 border=0 width=100%>\n";
    print "<tr><td nowrap><img src=\"$DIR_IMAGES/space.gif\" width=$gap height=1 border=0><img src=\"$bullet\" border=0>&nbsp;</td><td width=100%>";
    if ($i != $index) {
      print "<a href=\"./read.cgi?db=$DB&serial=$Serial\" onMouseOver=\"window.status=('Serial Number : $Serial'); return true\" onMouseOut=\"window.status=('')\"><font size=2>$Str</font></a>";
    }
    else {
      print "<font size=2 color=$CFG{'fg_thistitle'}>$Str</font>";
    }
    print "</td></tr>\n";
    print "</table>\n";
    print "</td>\n";

    $Str = &Text2Html($Name);
    print "<td background=\"$CFG{'img_tbg'}\">\n";
    print "<font size=2>";
    if ($Email) {
      print "<a href=\"mailto:$Email\" onMouseOver=\"window.status=('Send mail to the Author'); return true\" onMouseOut=\"window.status=('')\">$Str</a>";
    }
    else {
      print "$Str";
    }
    print "</font>\n";
    print "</td>\n";

    ($sec, $min, $hour, $mday, $mon, $year, $wday, $ydat, $isdst) = localtime($Date);
    $Str = sprintf("%02d/%02d/%02d", $year, $mon + 1, $mday);
    print "<td background=\"$CFG{'img_tbg'}\">\n";
    print "<font size=2>";
    if ($year == $cyear && $mon == $cmon && $mday == $cmday) {
      print "<font color=$CFG{'fg_today'}>$Str</font>";
    }
    else {
      print "<font color=$CFG{'fg_date'}>$Str</font>";
    }
    print "</font>\n";
    print "</td>\n";

    print "<td align=center background=\"$CFG{'img_tbg'}\">\n";
    print "<font size=2 color=$CFG{'fg_hits'}>$Inq</font>\n";
    print "</td>\n";

    print "<td align=center background=\"$CFG{'img_tbg'}\">\n";
    if ($Fname) {
      if ($TypeIMG{$Ftype}) {
        $imgIcon = $TypeIMG{$Ftype};
      }
      else {
        foreach $ext (keys %ExtIMG) {
          $strMatch = "\\.$ext\$";
          if ($Fname =~ /$strMatch/i) {
            $imgIcon = $ExtIMG{$ext};
            last;
          }
        }
      }
      $imgIcon = "$DIR_IMAGES/unknown.gif" if (!$imgIcon);

      print "<a href=\"./$DB/$DN_FILES/$Fname\" onMouseOver=\"window.status=('$Fname'); return true\" onMouseOut=\"window.status=('')\"><img src=\"$imgIcon\" width=16 height=16 border=0 align=bottom alt=\"$Fname\"></a>\n";
    }
    else {
      print "<img src=\"$DIR_IMAGES/space.gif\" border=0 width=1 height=1 alt=\"\">\n";
    }
    print "</td>\n";
    print "</tr>\n";
  }
  print "</table>\n";

  print "</center>\n";
  &Footer;
}
